import os
from os import pipe, fdopen
from subprocess import Popen


PROJECT_DIR = '/'.join(__file__.split('/')[:-2]) + '/'


class CVProgramLauncher:
    def __init__(self, team_color):
        self.team_color = team_color
        self._cv_process = None

    def __enter__(self):
        fd_input, fd_output = pipe()
        self._input_fd = fdopen(fd_input)
        self._cv_process = Popen(
            [
                "python3.6",
                PROJECT_DIR + "../cv-code/robots-at-robots/research/demos/demo_pipeline_camera.py",
                str(fd_output),
                self.team_color,
            ],
            env={
                'PYTHONPATH': PROJECT_DIR + '../cv-code/robots-at-robots:' + PROJECT_DIR + '/../cv-code/common',
                'PATH': os.environ['PATH'] + ';sbin',
                'DISPLAY': ':0.0',
            },
        )
        return self

    def __exit__(self, exc_type, exc_val, exc_tb):
        self._cv_process.terminate()
        self._cv_process.wait()

    def get_next_position(self):
        return self._input_fd.readline()
